/*
 * \brief  Test client for the Hello RPC interface
 * \author Björn Döbel
 * \date   2008-03-20
 */

/*
 * Copyright (C) 2008-2009
 * Genode Labs, Feske & Helmuth Systementwicklung GbR
 *
 * This file is part of the Genode OS framework, which is distributed
 * under the terms of the GNU General Public License version 2.
 */

#include <base/env.h>
#include <base/printf.h>
#include <sampling_session/client.h>
#include <timer_session/connection.h>
#include <sampling_session/connection.h>

using namespace Genode;

extern Sampling::Session_client *h;

int main(void)
{
	Sampling::Session_capability
		h_cap(env()->parent()->session(
			Sampling::Session::service_name(), "foo, ram_quota=4K"));
	Sampling::Session_client h(h_cap);

	Timer::Connection timer;
	int first_time = 1;
	Dataspace_capability ds_cap = h.get_cap();
	volatile void *ptr = Genode::env()->rm_session()->attach(ds_cap);
	Dataspace_capability ds_1 = h.get_cap();
	volatile void *ptr1 = Genode::env()->rm_session()->attach(ds_1);
	
	printf("CLIENT BEGIN: value is %d\n", *((int*)ptr1));
	int i = 0;
	while (i < 10) {
		//h.say_hello();
		//timer.msleep(1000);

		//int foo = h.add(2, 5);
		//PDBG("Added 2 + 5 = %d", foo);
		//timer.msleep(1000);
		
		PDBG("*******************About to get dataspace capability\n");

		
		if(first_time)
		{
			*((int*)ptr) += 4;
			first_time = 0;
		}
		
		PDBG("*****Got and wrote to the dataspace memory. The values are %d and %d\n", *((int*)ptr), *((int*)ptr1));
		*((int*)ptr1) += 10;
		
		i++;
	}

	return 0;
}
