#include "profile_port.h"
#include "my_hash.h"

#define SUM			'a'
#define COUNT		'b'
#define MINIMUM		'c'
#define MAXIMUM		'd'
#define AVG			'e'
#define STDEV		'f'

typedef struct
{
	//stores the aggregation entries
	struct hash_table *table;
	
	//information about the aggregations stored in this structure
	char aggregation_type;
	
	//information about the aggregation hash type elememts
	char *hash_type_sequence;
	
	char *value_sequence;
}aggregation;

//create the aggregation data structure.
aggregation *create_aggregation(char aggregation_type, int no_hash_types, ...);
int value_size(buffer_info *info, char *values);
char *convert_string_hash(aggregation *aggn, int no_args, ...);
struct hash_entry *first_entry(aggregation *aggn);

void sum_s(aggregation *aggn, char *hash_sequence, unsigned long value_add);
void count_s(aggregation *aggn, char *hash_sequence);
void min_s(aggregation *aggn, char *hash_sequence, double value);
void max_s(aggregation *aggn, char *hash_sequence, double value);
void stdev_s(aggregation *aggn, char *hash_sequence, double value);
void avg_s(aggregation *aggn, char *hash_sequence, double value);

int sum_w(buffer_info *info, char *values);
int count_w(buffer_info *info, char *values);
char *min_w(buffer_info *info, char *values);
char *max_w(buffer_info *info, char *values);
int stdev_w(buffer_info *info, char *values);
int avg_w(buffer_info *info, char *values);
