#include "profile_port.h"
#include "my_threads.h"
#include <cap_session/connection.h>
//#include "prof_specs.h"

using namespace Genode;

L4_ThreadId_t register_id;
L4_ThreadId_t matrix_id;

void registration_thread::thread_fn()
{
	register_id.raw = tid().l4id.raw;
	L4_MsgTag_t tag;
	L4_Msg_t msg;
	L4_ThreadId_t sender;

	L4_Word_t tid_register;
	//uintptr_t fn_ptr;
	L4_Word_t buffer;
	L4_Word_t index;
	while(1)
	{
		/* 
			message structure:
				- buffer address
		*/
		L4_MsgClear(&msg);
		tag = L4_Wait(&sender);
		L4_MsgStore(tag, &msg);
		tid_register = L4_MsgWord(&msg, 0);
		//fn_ptr = L4_MsgWord(&msg, 1);
		buffer = L4_MsgWord(&msg, 1);//2);
		if(buffer == 0)
		{
			index = enter_thread_entry(tid_register, NULL);//(uintptr_t)fn_ptr, NULL); 
		}
		else
		{
			index = enter_thread_entry(tid_register, (buffer_info*)buffer);//(uintptr_t)fn_ptr, (buffer_info*)buffer);
		}

		L4_MsgClear(&msg);		
		L4_MsgAppendWord(&msg, index);
		L4_MsgLoad(&msg);
		L4_Reply(sender);

	}
}
	
void registration_thread::entry()
{
	thread_fn();
}
	
void profiling_links::thread_fn()
{
	matrix_id.raw = tid().l4id.raw;

	L4_MsgTag_t tag;
	L4_Msg_t msg;	
	L4_ThreadId_t sender;

	L4_Word_t input_source_index = 0;
	L4_Word_t input_getter_index = 0;

	while(1)
	{
		L4_MsgClear(&msg);

		tag = L4_Wait(&sender);
		L4_MsgStore(tag, &msg);

		input_source_index = L4_MsgWord(&msg, 0);
		input_getter_index = L4_MsgWord(&msg, 1);
		L4_MsgClear(&msg);

		enter_matrix_entry(input_source_index, input_getter_index);

		buffer_info *buf1 = thread_buffer_info(input_getter_index);
		buffer_info *buf2 = thread_buffer_info(input_source_index);
		
		//if the thread that we're connecting to is not consolidating and
		//we've specified that the buffer is to consolidate data, set the state
		//to non-consolidation given that we can't consolidate data in the same
		//way as consolidation while collecting samples.
	
		//This is the likely source of the bug
		if(buf2 != NULL && buf2->storage_mode == CONSOLIDATE)
		{
			if(buf1 != NULL && buf1->storage_mode == NO_CONSOLIDATE)
			{
//				buf2->storage_mode == NO_CONSOLIDATE;
			}
		}
	
		if(buf1 != NULL && buf1->storage_mode == CONSOLIDATE)
		{
			L4_MsgAppendWord(&msg, buf1->core_size); //size of core buffer
			L4_MsgAppendWord(&msg, buf1->size);		 //sampling buffer size
			L4_MsgAppendWord(&msg, 1);				 //consolidating or not
			L4_MsgAppendWord(&msg, buf1->time_window);
			L4_MsgAppendWord(&msg, buf1->no_windows);
			L4_MsgLoad(&msg);
		}
		else if(buf1 != NULL && buf1->storage_mode == NO_CONSOLIDATE)
		{//within this, add another condition to return other information if the current
		 //buffer is aggregating samples
			L4_MsgAppendWord(&msg, 40);
			L4_MsgAppendWord(&msg, 0);
			L4_MsgAppendWord(&msg, 0);
			L4_MsgAppendWord(&msg, buf1->time_window);
			L4_MsgAppendWord(&msg, buf1->no_windows);
			L4_MsgLoad(&msg);
		}
		L4_Reply(sender);
	}
}
	
void profiling_links::entry()
{
	thread_fn();
}

