#include <base/env.h>

namespace Okl4{ extern "C" {
#include <l4/thread.h>
}}

using namespace Okl4;

template <class T>
class ProfVector
{
public:
	int length;
	T *buffer;
	
	ProfVector(int l)
	{
		length = l;
		buffer = new(Genode::env()->heap()) T[length];
	}
	
	void insert(int index, T element)
	{
		buffer[index] = element;
	}
};

void suspend(ProfVector<L4_ThreadId_t> *vec);
void resume(ProfVector<L4_ThreadId_t> *vec, L4_ThreadId_t phase_id);
void kill(ProfVector<L4_ThreadId_t> *vec);
