#include "profile_port.h"
#include <util/string.h>

using namespace Genode;
/*
	typinfo incorporated in buffer struct
	- Basic type:
		id of -1, tuple type is basic type. name is name of basic type
		
	pre-defined tuples aliases:
		- sample_1 -> (int, int)
		- sample_2 -> (int, int, int)
*/

int type_index = 3;
volatile tinfo regd_types[1000];

void type_table_init()
{
	/*
		Already have some pre-defined tuples defined above
	*/
	regd_types[0].type_id = 0;
	regd_types[0].tup_type_seq = (char*)"I";
	
	regd_types[1].type_id = 1;
	regd_types[1].tup_type_seq = (char*)"II";
	
	regd_types[2].type_id = 2;
	regd_types[2].tup_type_seq = (char*)"III";
}

int find_type_seq(char *seq)
{
	int i;
	for(i = 0;i < type_index;i++)
	{
		if(strlen(seq) > strlen((char*)regd_types[i].tup_type_seq))
		{
			if(memcmp(seq, (char*)regd_types[i].tup_type_seq, strlen(seq)) == 0)
				return i;
		}
		else
		{
			if(memcmp(seq, (char*)regd_types[i].tup_type_seq, strlen((char*)regd_types[i].tup_type_seq)) == 0)
				return i;
		}
	}
	
	regd_types[i].type_id = i;
	regd_types[i].tup_type_seq = new(Genode::env()->heap()) char[Genode::strlen(seq) + 1];
	Genode::memcpy((char*)regd_types[i].tup_type_seq, seq, Genode::strlen(seq) + 1);
	type_index++;
	return i;
}

tinfo *get_stats(int index)
{
	/*
		Operations to perform:
		 - check for valid array index
		 - if valid, return pointer to struct
		 - otherwise, return nothing
	*/
	if(index >= type_index)
	{
		return (tinfo*)NULL;
	}
	
	return (tinfo*)(&regd_types[index]);
}
